<?php
/* --------------------------------------------------------------
   dependent.inc.php 2017-05-04
   Gambio GmbH
   http://www.gambio.de
   Copyright © 2017 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/**
 * HTML whitespace stripping
 */
$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "HTML_COMPRESSION"', true);
if($check->num_rows === 0)
{
	$query = 'INSERT INTO `configuration` 
				SET configuration_key = "HTML_COMPRESSION", 
					configuration_value = "false",
					configuration_group_id = "14",
					sort_order = "5",
					use_function = NULL,
					set_function = "gm_cfg_select_option(array(\'true\', \'false\'),",
					date_added = NOW()';
	$t_success &= $this->query($query, true);
}

/**
 * HEAD CSS INLINE OUTPUT
 */
$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "CSS_INLINE_OUTPUT"', true);
if($check->num_rows === 0)
{
	$query = 'INSERT INTO `configuration` 
				SET configuration_key = "CSS_INLINE_OUTPUT", 
					configuration_value = "false",
					configuration_group_id = "14",
					sort_order = "6",
					use_function = NULL,
					set_function = "gm_cfg_select_option(array(\'true\', \'false\'),",
					date_added = NOW()';
	$t_success &= $this->query($query, true);
}

/**
 * Social bookmarking removal
 */

// admin_access: gm_bookmarks
$t_check = $this->table_column_exists('admin_access', 'gm_bookmarks');
if($t_check)
{
	$query = 'ALTER TABLE `admin_access` DROP COLUMN `gm_bookmarks`';
	$t_success &= $this->query($query, true);
}

// admin_access: gm_bookmarks_action
$t_check = $this->table_column_exists('admin_access', 'gm_bookmarks_action');
if($t_check)
{
	$query = 'ALTER TABLE `admin_access` DROP COLUMN `gm_bookmarks_action`';
	$t_success &= $this->query($query, true);
}


$check = $this->query("DESCRIBE `admin_access` 'gm_sql'", true);
if($check->num_rows === 1)
{
	$query = 'ALTER TABLE `admin_access` DROP `gm_sql`';
	$t_success &= $this->query($query);
}

$check = $this->query("DESCRIBE `admin_access` 'minisql'", true);
if($check->num_rows === 1)
{
	$query = 'ALTER TABLE `admin_access` DROP `minisql`';
	$t_success &= $this->query($query);
}

/**
 * In some countries, federal states are always necessary.
 */

$t_check = $this->table_column_exists('countries', 'is_state_mandatory');
if(!$t_check)
{
	$query = 'ALTER TABLE countries ADD COLUMN is_state_mandatory INT DEFAULT 0';
	$t_success &= $this->query($query, true);
}

/**
 * Change the length of the column zone_name of the table zones so that longer zone names can be inserted.
 */

$t_check = $this->table_column_exists('zones', 'zone_name');
if($t_check)
{
	$query = 'ALTER TABLE zones MODIFY zone_name VARCHAR(128) NOT NULL DEFAULT \'\'';
	$t_success &= $this->query($query, true);
}

/**
 * Change the last modified column in several tables. On update they should be set to the current timestamp/date_time.
 */

$t_check = $this->table_column_exists('address_book', 'address_last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `address_book` MODIFY `address_last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('amzadvpay_authorizations', 'last_update');
if($t_check)
{
	$query = 'ALTER TABLE `amzadvpay_authorizations` MODIFY `last_update` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('amzadvpay_captures', 'last_update');
if($t_check)
{
	$query = 'ALTER TABLE `amzadvpay_captures` MODIFY `last_update` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('amzadvpay_orders', 'last_update');
if($t_check)
{
	$query = 'ALTER TABLE `amzadvpay_orders` MODIFY `last_update` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('amzadvpay_refunds', 'last_update');
if($t_check)
{
	$query = 'ALTER TABLE `amzadvpay_refunds` MODIFY `last_update` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('campaigns', 'last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `campaigns` MODIFY `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('card_blacklist', 'last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `card_blacklist` MODIFY `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('categories', 'last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `categories` MODIFY `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('configuration', 'last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `configuration` MODIFY `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('content_manager', 'gm_last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `content_manager` MODIFY `gm_last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('coupons', 'date_modified');
if($t_check)
{
	$query = 'ALTER TABLE `coupons` MODIFY `date_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('currencies', 'last_updated');
if($t_check)
{
	$query = 'ALTER TABLE `currencies` MODIFY `last_updated` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('customers', 'customers_last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `customers` MODIFY `customers_last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('customers_info', 'customers_info_date_account_last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `customers_info` MODIFY `customers_info_date_account_last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('export_schemes', 'date_modified');
if($t_check)
{
	$query = 'ALTER TABLE `export_schemes` MODIFY `date_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('geo_zones', 'last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `geo_zones` MODIFY `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('infobox_messages', 'date_modified');
if($t_check)
{
	$query = 'ALTER TABLE `infobox_messages` MODIFY `date_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('language_phrases_cache', 'date_modified');
if($t_check)
{
	$query = 'ALTER TABLE `language_phrases_cache` MODIFY `date_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('manufacturers', 'last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `manufacturers` MODIFY `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('mf_claims', 'lastChange');
if($t_check)
{
	$query = 'ALTER TABLE `mf_claims` MODIFY `lastChange` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('orders', 'last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `orders` MODIFY `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('orders_shopgate_order', 'modified');
if($t_check)
{
	$query = 'ALTER TABLE `orders_shopgate_order` MODIFY `modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('payone_transactions', 'last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `payone_transactions` MODIFY `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('products', 'products_last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `products` MODIFY `products_last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('reviews', 'last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `reviews` MODIFY `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('specials', 'specials_last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `specials` MODIFY `specials_last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('tax_class', 'last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `tax_class` MODIFY `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('tax_rates', 'last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `tax_rates` MODIFY `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('zones_to_geo_zones', 'last_modified');
if($t_check)
{
	$query = 'ALTER TABLE `zones_to_geo_zones` MODIFY `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
	$t_success &= $this->query($query, true);
}


/**
 * Add Gambio Hub Client Key Entry
 */
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GAMBIO_HUB_CLIENT_KEY"', true);
if($check->num_rows === 0)
{
	$query = 'INSERT INTO `gm_configuration` 
				SET gm_key = "GAMBIO_HUB_CLIENT_KEY", 
					gm_value = ""';
	$t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GAMBIO_HUB_MONEY_ORDER_PAY_TO"', true);
if($check->num_rows === 0)
{
	$query = 'INSERT INTO `gm_configuration` 
				SET gm_key = "GAMBIO_HUB_MONEY_ORDER_PAY_TO", 
					gm_value = ""';
	$t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "MODULE_PAYMENT_GAMBIO_HUB_STATUS"',
                      true);
if($check->num_rows === 0)
{
	$query = "INSERT INTO configuration
(configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added)
VALUES ('MODULE_PAYMENT_GAMBIO_HUB_STATUS', 'False', '6', '1', 'gm_cfg_select_option(array(\'True\', \'False\'), ', now())";
	$t_success &= $this->query($query, true);
	
	$query = "INSERT INTO configuration
(configuration_key, configuration_value,  configuration_group_id, sort_order, date_added)
VALUES ('MODULE_PAYMENT_GAMBIO_HUB_ALLOWED', '', '6', '0', now())";
	$t_success &= $this->query($query, true);
	
	$query = "INSERT INTO configuration
(configuration_key, configuration_value,  configuration_group_id, sort_order, date_added)
VALUES ('MODULE_PAYMENT_GAMBIO_HUB_SORT_ORDER', '0', '6', '0', now())";
	$t_success &= $this->query($query, true);
	
	$query = "INSERT INTO configuration
(configuration_key, configuration_value,  configuration_group_id, sort_order, use_function, set_function, date_added)
VALUES ('MODULE_PAYMENT_GAMBIO_HUB_ZONE', '0', '6', '2', 'xtc_get_zone_class_title', 'xtc_cfg_pull_down_zone_classes(', now())";
	$t_success &= $this->query($query, true);
	
	$query = "INSERT INTO configuration
(configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added)
VALUES ('MODULE_PAYMENT_GAMBIO_HUB_ORDER_STATUS_ID', '0', '6', '0', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())";
	$t_success &= $this->query($query, true);
	
	$query = "INSERT INTO configuration 
(configuration_key, configuration_value, configuration_group_id, sort_order, date_added) 
VALUES ('MODULE_PAYMENT_GAMBIO_HUB_URL', 'https://core-api.gambiohub.com/a/api.php/api/v1', '6', '0', now())";
	$t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "MODULE_PAYMENT_GAMBIO_HUB_SETTINGS_APP_URL"',
                      true);
if($check->num_rows === 0)
{
	$query = "INSERT INTO configuration 
(configuration_key, configuration_value, configuration_group_id, sort_order, date_added) 
VALUES ('MODULE_PAYMENT_GAMBIO_HUB_SETTINGS_APP_URL', 'https://gui.gambiohub.com/a/settings', '6', '0', now())";
	$t_success &= $this->query($query, true);
	
	$query = "INSERT INTO configuration 
(configuration_key, configuration_value, configuration_group_id, sort_order, date_added) 
VALUES ('MODULE_PAYMENT_GAMBIO_HUB_ACCOUNT_APP_URL', 'https://gui.gambiohub.com/a/account', '6', '0', now())";
	$t_success &= $this->query($query, true);
}

$check = $this->query("DESCRIBE `orders` 'gambio_hub_module'", true);
if($check->num_rows == 0)
{
	$t_query = "ALTER TABLE `orders` ADD COLUMN `gambio_hub_module` VARCHAR(32) DEFAULT ''";
	$t_success &= $this->query($t_query);
}

$check = $this->query("DESCRIBE `orders` 'gambio_hub_module_title'", true);
if($check->num_rows == 0)
{
	$t_query = "ALTER TABLE `orders` ADD COLUMN `gambio_hub_module_title` VARCHAR(255) DEFAULT ''";
	$t_success &= $this->query($t_query);
}

$check = $this->query("DESCRIBE `orders` 'gambio_hub_transaction_code'", true);
if($check->num_rows == 0)
{
	$t_query = "ALTER TABLE `orders` ADD COLUMN `gambio_hub_transaction_code` VARCHAR(64) DEFAULT ''";
	$t_success &= $this->query($t_query);
}

$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "MODULE_PAYMENT_GAMBIO_HUB_IP_LIST_URL"',
                      true);
if($check->num_rows === 0)
{
	$query = "INSERT INTO configuration 
(configuration_key, configuration_value, configuration_group_id, sort_order, date_added) 
VALUES ('MODULE_PAYMENT_GAMBIO_HUB_IP_LIST_URL', 'https://core-api.gambiohub.com/trust/hub_hosts.json', '6', '0', now())";
	$t_success &= $this->query($query, true);
}


/**
 * Add possibility to change product image resolutions for grid and listview
 */
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "USE_SMALLER_IMAGES_FOR_PRODUCTS"', true);
if($check->num_rows === 0)
{
    $query = 'INSERT INTO `gm_configuration` 
				SET gm_key = "USE_SMALLER_IMAGES_FOR_PRODUCTS", 
					gm_value = "0"';
    $t_success &= $this->query($query, true);
}


/**
 * Add possibility to list contents in robots.txt
 */
$t_check = $this->table_column_exists('content_manager', 'gm_robots_entry');
if(!$t_check)
{
	$query = 'ALTER TABLE `content_manager` ADD COLUMN `gm_robots_entry` int(1) NOT NULL DEFAULT "0" AFTER `gm_sitemap_entry`';
	$t_success &= $this->query($query, true);
	
	/**
	 * Alter content_manager.gm_robots_entry for legal texts to disallow indexing these contents.
	 */
	/* 2 = Datenschutz
	 * 3 = AGB
	 * 4 = Impressum
	 * 9 = Widerruf
	 * 3889891 = Versand- & Zahlungsbedingungen
	 * 3889895 = Widerrufsrecht und Widerrufsformular
	 */
	$t_group_ids = array(2, 3, 4, 9, 3889891, 3889895);
	$t_query  = "UPDATE `content_manager` 
				SET `gm_robots_entry` = 1 
				WHERE `content_group` IN (" . implode(', ', $t_group_ids) . ")";
	$t_success &= is_numeric($this->query($t_query));
}

/**
 * Add possibility to change the category depth of the horizontal category menu
 */
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "CATEGORY_TOP_SHOW_LEVEL"', true);
if($check->num_rows === 0)
{
    $query = 'INSERT INTO `gm_configuration` 
				SET gm_key = "CATEGORY_TOP_SHOW_LEVEL", 
					gm_value = "2"';
    $t_success &= $this->query($query, true);
}
